#pragma once

#include <cstdint>
#include <unordered_map>
#include <ReArchive/types/FileEntry.h>

namespace ReArchive {
    class FileTable;
}

class ReArchive::FileTable {
protected:
    // count
    // TODO unordered_set so time to find a particular entry doesn't depend on the length.
    std::unordered_map<std::filesystem::path, FileEntry> entries;
public:
    void Append(const FileEntry& file_entry);
    void Remove(const FileEntry& file_entry);
    [[nodiscard]] std::unordered_map<std::filesystem::path, FileEntry> GetEntries() const { return entries; }
    [[nodiscard]] int64_t Count() const { return entries.size(); }
public:
    [[nodiscard]] static std::vector<unsigned char> Serialize(const FileTable& file_table);
public:
    FileTable() = default;
    ~FileTable() = default;

};